'
'LCD-Modul mit Hitachi HD44780
'
'
'HD44780.BAS
'
'Konstanten:
'---------
'

symbol s_in=7			'Eingang serielle Schnittstelle
symbol e=5			'E-Signal LCD
symbol rs=4			'RS-Signal LCD
symbol lcd=%01111111		'I/O-Definition
symbol space=32			
'
'Variablen:
'--------
'

symbol hilf=b2			'Hilfsregister
symbol zeichen=b3		'aktuelles Zeichen
symbol index=b4			'Zaehlvariable
'
'Programmstart
'

	bsave
	eeprom 0,("Berufsfoerderungswerk Birkenfeld")
	pins=0			'alle Ports Low
	dirs=lcd		'I/O Definition
	pause 200		'LCD-Reset abwarten
'
'LCD initialisieren
'

lcd_init:

	pins=%00000011		'Betriebsart 8bit
	pulsout e,1		'ausgeben
	pause 10		'Reaktionszeit abwarten
	pulsout e,1		'ausgeben
	pause 10
	pulsout e,1
	pause 10
	pins=%00000010		'Betriebsart 4bit
	pulsout e,1		'ausgeben
	pulsout e,1
	pulsout e,1
	zeichen=14
	gosub wr_lcd
	zeichen=44		'LCD funktion set(siehe Datenblatt)
	gosub wr_lcd		'an LCD senden
	zeichen=6		'Cursor ein
	gosub wr_lcd		'an LCD senden
	zeichen=1		'LCD lschen
	gosub wr_lcd 		'an LCD senden
	high rs			'Umschalten auf Zeichen senden
'
'Hauptprogrammschleife
'
'Empfngt ein ASCII-Zeichen ber Pin 7 und zeigt es an.
'
haupt:

	serin s_in,T2400,zeichen	'warten auf Zeichen
	if zeichen>30 then out		'kein ausgeben von Steuerzeichen
	if zeichen=12 then clear	'Ctr-l lscht LCD
	if zeichen=13 then zurueck	'CR geht in Position 1
	if zeichen=8 then bs		'Backspace
	if zeichen=20 then text1	'Ctr-t Ausgabe Text1
	if zeichen=19 then text2	'Ctr-s Ausgabe Text2
	goto haupt
bs:

	low RS			'RS=low
	zeichen=16		'Cursor nach links
	gosub wr_lcd		'ausgeben
	high RS			'RS high
	zeichen=space		'Leerzeichen laden
	GOSUB WR_lcd		'und ausgeben
	low RS 			'RS Low
	zeichen=16		'Cursor nach links
	gosub wr_lcd		'ausgeben
	high RS
	goto haupt

clear:

	low RS			'RS Low
	zeichen=1		'LCD lschen
	gosub wr_lcd		'ausgeben
	high RS
	goto haupt

zurueck:

	low RS
	zeichen=3		'Cursor Home
	gosub wr_lcd
	high RS
	goto haupt

out:

	gosub wr_lcd		'Zeichen ausgeben
	goto haupt

text1:
	low RS
	zeichen=1
	gosub wr_lcd
	High RS
	for index=0 to 16
	read index,zeichen
	gosub wr_lcd
	pause 50
	next index
	goto haupt

text2:

	eeprom 0,("Alles OK Texr 2!")
	goto text1
'
'Unterprogramm
'
wr_lcd:

	pins=pins & %00010000		'RS High
	hilf=zeichen /16		'oberse Nibble in Hilfsvariable
	pins=pins | hilf		'Nibble ausgeben
	pulsout e,1			'bernahmeimpuls
	hilf=zeichen & %00001111	'unteres Nibble
	pins=pins & %00010000		'oberse Nibble lschen
	pins=pins | hilf		'unteres Nibble ausgeben
	pulsout e,1
	return

			